/*
 * GrantsGovConstantsUtils.java
 *
 * @author  Dan Dumitru
 * Created on 2003-08-08
 */

package gov.grants.utility;

// Sun

// Apache
//import org.apache.log4j.Logger;

// Grants.gov
import gov.grants.utility.GrantsGovConstants;

/**
 *  Static methods supporting DataEntryConstants
 *
 */
public class GrantsGovConstantsUtils {
    
//    final static Logger log = Logger.getLogger( GrantsGovConstantsUtils.class.getName() );
    
    private GrantsGovConstantsUtils() {}
    
    /***********************
     *  :: STATIC METHODS ::
     **********************/
    
  
   
    /**
     *  Used for getting the application path from Weblogic
     */
    public static String getApplicationPath() {
    	StringBuffer appPath = new StringBuffer();
    	
        System.out.println( "user.dir=" + System.getProperty( "user.dir" ) );
        appPath.append( System.getProperty( "user.dir" ) );
        appPath.append( System.getProperty( "file.separator" ) );
        appPath.append( "config" );
        appPath.append( System.getProperty( "file.separator" ) );  
        System.out.println( "weblogic.Domain=" + System.getProperty( "weblogic.Domain" ) );
        appPath.append( System.getProperty( "weblogic.Domain" ) );
        appPath.append( System.getProperty( "file.separator" ) );
        appPath.append( "applications");
        appPath.append( System.getProperty( "file.separator" ) );
        appPath.append( GrantsGovConstants.ROOT_DIR );
        appPath.append( System.getProperty( "file.separator" ) );
        
        System.out.println( "==> appPath=" + appPath.toString() );
        return appPath.toString();
    	
    }// getApplicationPath()
    
    /**
     *  This method checks for the System file-separator, if it exists,
     *  it will simply return the path, else it will append the 
     *  file-separator to the given path and return the updated path.
     *  This was added due to the difference between Weblogic and Tomcat
     *  when getting the ServletContext's realPath for the root directory: 
     *      ServletContext context = getServletContext();
     *      context.getRealPath( "/" );
     *  Tomcat would append the file-separator and Weblogic would not
     */
    public static String getApplicationPath( String path ) {
    	int end = path.length() - 1;
        String lastChar = path.substring( end );
        System.out.println( "==> last char=" + lastChar );
        if ( lastChar.equals( System.getProperty( "file.separator" ) ) ) {
            System.out.println( "already has separator" );
        } else {
            System.out.println( "adding separator" );
            path = path + System.getProperty( "file.separator" );
        }// if-else
        
        return path;
    	
    }// getApplicationPath()
	
	public static void setSystemProperties(){
		// Weblogic overrides javax.xml.soap.MessageFactory to 
		// use it's own classes
//		System.setProperty( "javax.xml.soap.MessageFactory", "com.sun.xml.messaging.saaj.soap.ver1_1.SOAPMessageFactory1_1Impl" );
		System.setProperty( "javax.xml.soap.MessageFactory", "com.sun.xml.messaging.saaj.soap.MessageFactoryImpl" );
//		System.setProperty( "javax.xml.soap.MessageFactory", "javax.xml.soap.MessageFactory" );
		System.setProperty( "org.xml.sax.driver", "org.apache.xerces.parsers.SAXParser" );
		System.setProperty( "org.xml.sax.parser", "org.xml.sax.Parser" );
		System.setProperty( "javax.xml.parsers.SAXParserFactory", "org.apache.xerces.jaxp.SAXParserFactoryImpl" );
		System.setProperty( "javax.xml.parsers.DocumentBuilderFactory", "org.apache.xerces.jaxp.DocumentBuilderFactoryImpl" );
//		System.getProperties().list( System.out );
	}

}// GrantsGovConstantsUtils