/*
 * GetApplicationListReceivedMessage.java
 *
 * Created on August 19, 2003, 11:19 AM
 *
 * @author  david.xia
 */

package gov.grants.webSvcs.utility;

// Sun
import javax.xml.soap.*;
import javax.xml.messaging.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.transform.*;
import javax.naming.*;

import java.io.InputStream;

// jwsdp - sun
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;


public class GetApplicationListReceivedMessage {
    
    private String filterType;
    
    private String filterValue;
    
    /** Creates a new instance of GetApplicationListReceivedMessage */
    public GetApplicationListReceivedMessage(SOAPMessage requestMessage)throws javax.xml.soap.SOAPException, org.xml.sax.SAXException, java.io.IOException {
        SOAPPart soapPart;
        SOAPEnvelope soapEnvelope;
        SOAPBody soapBody;
        javax.xml.soap.Name functionName;
        javax.xml.soap.Name filterTypeName;
        javax.xml.soap.Name filterValueName;

        
        soapPart = requestMessage.getSOAPPart();
        soapEnvelope = soapPart.getEnvelope();
        soapBody = soapEnvelope.getBody();
        // Search for Fuction name
        functionName = soapEnvelope.createName("GetApplicationList","agis","www.grants.gov/AgencyIntegrationService");
        
        // Check there's at least one such element.
        java.util.Iterator valueRequests = soapBody.getChildElements(functionName);
        if (! valueRequests.hasNext()) {
        // Schema is not valid
         };
        
        // Check there's no more than one of such Function .
        SOAPElement soapGetApplicationListElement = (SOAPElement)valueRequests.next();
        if (valueRequests.hasNext()) {
        // Schema is not valid
        }
        
        // Look for the appropriate child element containing the name parameter.
        filterTypeName = soapEnvelope.createName("FilterType");
        java.util.Iterator params = soapGetApplicationListElement.getChildElements(filterTypeName);
        if (! params.hasNext()) {
        // Schema is not valid
        }
        
        // Ensure there's only one such element.
        SOAPElement soapFilterTypeElement = (SOAPElement)params.next();
        if (params.hasNext()) {
        // Schema is not valid
        }
        
        // Attempt to read out the value of FilterType
        filterType = soapFilterTypeElement.getValue();
        if (null == filterType) {
        // Schema is not valid
        }

        
        
        // Look for the appropriate child element containing the name parameter.
        filterValueName = soapEnvelope.createName("FilterValue");
        params = soapGetApplicationListElement.getChildElements(filterValueName);
        if (! params.hasNext()) {
        // Schema is not valid
        }
        // Ensure there's only one such element.
        SOAPElement soapFilterValueElement = (SOAPElement)params.next();
        if (params.hasNext()) {
        // Schema is not valid
        }
        
        // Attempt to read out the value of FilterType
        filterValue = soapFilterValueElement.getValue();
        if (null == filterType) {
        // Schema is not valid
        }        
  
	}
    
    public String getFilterType() {
        return filterType;
    }
    
    public String getFilterValue() {
        return filterValue;
    }
    
}
